【Leetcode】486. Predict the Winner

来源:互联网 发布:ubuntu引导分区大小 编辑:程序博客网 时间:2024/05/24 00:35

Description:

Given an array of scores that are non-negative integers. Player 1 picks one of the numbers from either end of the array followed by the player 2 and then player 1 and so on. Each time a player picks a number, that number will not be available for the next player. This continues until all the scores have been chosen. The player with the maximum score wins.

Given an array of scores, predict whether player 1 is the winner. You can assume each player plays to maximize his score.

Example:

Input: [1, 5, 2]Output: False

Explanation: Initially, player 1 can choose between 1 and 2.
If he chooses 2 (or 1), then player 2 can choose from 1 (or 2) and 5. If player 2 chooses 5, then player 1 will be left with 1 (or 2).
So, final score of player 1 is 1 + 2 = 3, and player 2 is 5.
Hence, player 1 will never be the winner and you need to return False.

Input: [1, 5, 233, 7]Output: True

Explanation: Player 1 first chooses 1. Then player 2 have to choose between 5 and 7. No matter which number player 2 choose, player 1 can choose 233.
Finally, player 1 has more score (234) than player 2 (12), so you need to return True representing player1 can win.

Note:

1 length of the array <= 20.
Any scores in the given array are non-negative integers and will not exceed 10,000,000.
If the scores of both players are equal, then player 1 is still the winner.


思路:

本题可使用动态规划来解决。
首先,需要判断玩家1能否赢得比赛,判断条件可以为玩家1赢得分数比玩家2多。关键的问题在于如何确定玩家1和玩家2的分数。由于玩家1是第一个进行选择的,可以选择序列A[i,j]中的i或j,那么得到的分数为A[i]或A[j]。如果选择了A[i],则产生序列A[i+1,j]给第二个玩家进行选择;而同理选择A[j]则产生序列A[i,j-1]。
为了让玩家1赢得分数比玩家2多,那么玩家1每次选择的数应使得分数差值最大(score1-score2)。那么将这个问题融入到上述推到中,可以建立dp[i][j]来表示序列[i,j]中玩家1分数减去玩家2分数的值。由于玩家1是首选者,对于dp[i][i],玩家2分数为0,差值则为nums[i]。那么对于dp[i][j],则玩家1的分数可增加nums[i]或nums[j],相应地减去dp[i+1][j]或dp[i][j-1]的值,这可以反过来把dp[i+1][j]或dp[i][j-1]的值看作是玩家2的最优化策略后得到的值。

以下是使用C++的实现过程:

class Solution {public:    bool PredictTheWinner(vector<int>& nums) {        int n = nums.size();        vector<vector<int> > dp(n, vector<int>(n));         for (int i = 0; i < n; i++) dp[i][i] = nums[i];        for (int i = n-2; i >= 0; i--) {            for (int j = i+1; j < n; j++) {                dp[i][j] = max(nums[i]-dp[i+1][j], nums[j]-dp[i][j-1]);            }        }        return dp[0][n-1] >= 0;     }};
0 0